Index: /trunk/LMDZ.MARS/libf/dyn3d/infotrac.F90
===================================================================
--- /trunk/LMDZ.MARS/libf/dyn3d/infotrac.F90	(revision 1036)
+++ /trunk/LMDZ.MARS/libf/dyn3d/infotrac.F90	(revision 1036)
@@ -0,0 +1,135 @@
+MODULE infotrac
+
+IMPLICIT NONE
+! nqtot : total number of tracers and higher order of moment, water vapor and liquid included
+  INTEGER, SAVE :: nqtot
+  INTEGER,allocatable :: iadv(:)   ! tracer advection scheme number
+  CHARACTER(len=20),allocatable ::  tnom(:) ! tracer name
+
+CONTAINS
+
+      subroutine iniadvtrac(nq,numvanle)
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! routine which initializes tracer names and advection schemes
+! reads these infos from file 'traceur.def' but uses default values
+! if that file is not found.
+! Ehouarn Millour. Oct. 2008  (made this LMDZ4-like) for future compatibility 
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+      IMPLICIT NONE
+
+#include "dimensions.h"
+!#include "advtrac.h"
+#include "control.h"
+
+! routine arguments:
+      INTEGER,INTENT(out) :: nq ! number of tracers
+      INTEGER,INTENT(out) :: numvanle
+
+! local variables:
+      LOGICAL :: first
+      INTEGER :: iq
+      INTEGER :: ierr
+      CHARACTER(len=3) :: qname
+
+! Look for file traceur.def
+      OPEN(90,file='traceur.def',form='formatted',status='old', &
+              iostat=ierr)
+      IF (ierr.eq.0) THEN
+        write(*,*) "iniadvtrac: Reading file traceur.def"
+        ! read number of tracers:
+        read(90,*,iostat=ierr) nq
+        if (ierr.ne.0) then
+          write(*,*) "iniadvtrac: error reading number of tracers"
+          write(*,*) "   (first line of traceur.def) "
+          stop
+        endif
+        
+        ! allocate arrays:
+        allocate(iadv(nq))
+        allocate(tnom(nq))
+        
+        ! initialize advection schemes to Van-Leer for all tracers
+        do iq=1,nq
+          iadv(iq)=3 ! Van-Leer
+        enddo
+        
+        do iq=1,nq
+        ! minimal version, just read in the tracer names, 1 per line
+          read(90,*,iostat=ierr) tnom(iq)
+          if (ierr.ne.0) then
+            write(*,*) 'iniadvtrac: error reading tracer names...'
+            stop
+          endif
+        enddo !of do iq=1,nq
+        close(90) ! done reading tracer names, close file
+      ENDIF ! of IF (ierr.eq.0)
+
+!  ....  Choix  des shemas d'advection pour l'eau et les traceurs  ...
+!  ...................................................................
+!
+!     iadv = 1    shema  transport type "humidite specifique LMD"  
+!     iadv = 2    shema   amont
+!     iadv = 3    shema  Van-leer
+!     iadv = 4    schema  Van-leer + humidite specifique
+!                        Modif F.Codron
+! 
+!
+      DO  iq = 1, nq-1
+       IF( iadv(iq).EQ.1 ) PRINT *,' Choix du shema humidite specifique'&
+       ,' pour le traceur no ', iq
+       IF( iadv(iq).EQ.2 ) PRINT *,' Choix du shema  amont',' pour le'  &
+       ,' traceur no ', iq
+       IF( iadv(iq).EQ.3 ) PRINT *,' Choix du shema  Van-Leer ',' pour' &
+       ,'le traceur no ', iq
+
+       IF( iadv(iq).EQ.4 )  THEN
+         PRINT *,' Le shema  Van-Leer + humidite specifique ',          &
+       ' est  uniquement pour la vapeur d eau .'
+         PRINT *,' Corriger iadv( ',iq, ')  et repasser ! '
+         CALL ABORT
+       ENDIF
+
+       IF( iadv(iq).LE.0.OR.iadv(iq).GT.4 )   THEN
+        PRINT *,' Erreur dans le choix de iadv (nqtot).Corriger et '    &
+       ,' repasser car  iadv(iq) = ', iadv(iq)
+         CALL ABORT
+       ENDIF
+      ENDDO
+
+       IF( iadv(nq).EQ.1 ) PRINT *,' Choix du shema humidite '          &
+       ,'specifique pour la vapeur d''eau'
+       IF( iadv(nq).EQ.2 ) PRINT *,' Choix du shema  amont',' pour la'  &
+       ,' vapeur d''eau '
+       IF( iadv(nq).EQ.3 ) PRINT *,' Choix du shema  Van-Leer '         &
+       ,' pour la vapeur d''eau'
+       IF( iadv(nq).EQ.4 ) PRINT *,' Choix du shema  Van-Leer + '       &
+       ,' humidite specifique pour la vapeur d''eau'
+!
+       IF( (iadv(nq).LE.0).OR.(iadv(nq).GT.4) )   THEN
+        PRINT *,' Erreur dans le choix de iadv (nqtot).Corriger et '    &
+       ,' repasser car  iadv(nqtot) = ', iadv(nqtot)
+         CALL ABORT
+       ENDIF
+
+      first = .TRUE.
+      numvanle = nq + 1
+      DO  iq = 1, nq
+        IF(((iadv(iq).EQ.3).OR.(iadv(iq).EQ.4)).AND.first ) THEN
+          numvanle = iq
+          first    = .FALSE. 
+        ENDIF
+      ENDDO
+!
+      DO  iq = 1, nq
+
+      IF( (iadv(iq).NE.3.AND.iadv(iq).NE.4).AND.iq.GT.numvanle )  THEN
+          PRINT *,' Il y a discontinuite dans le choix du shema de ',   &
+          'Van-leer pour les traceurs . Corriger et repasser . '
+           CALL ABORT
+      ENDIF
+
+      ENDDO
+!
+      end subroutine iniadvtrac
+
+END MODULE infotrac
Index: /trunk/LMDZ.MARS/libf/dyn3d/lect_start_archive.F
===================================================================
--- /trunk/LMDZ.MARS/libf/dyn3d/lect_start_archive.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/dyn3d/lect_start_archive.F	(revision 1036)
@@ -1,3 +1,3 @@
-      SUBROUTINE lect_start_archive(date,tsurf,tsoil,emis,q2,
+      SUBROUTINE lect_start_archive(nqtot,date,tsurf,tsoil,emis,q2,
      &     t,ucov,vcov,ps,co2ice,h,phisold_newgrid,
      &     q,qsurf,surfith,nid)
@@ -16,5 +16,5 @@
 c
 c=======================================================================
-
+      use infotrac, only: tnom
       implicit none
 
@@ -38,5 +38,5 @@
 #include "netcdf.inc"
 !#include "tracer.h"
-#include"advtrac.h"
+!#include"advtrac.h"
 c=======================================================================
 c   Declarations
@@ -49,6 +49,5 @@
 c et autres:
 c----------
-      INTEGER lnblnk
-      EXTERNAL lnblnk
+      integer,intent(in) :: nqtot ! number of advected tracers
 
 c Variables pour les lectures des fichiers "ini" 
@@ -85,5 +84,5 @@
       REAL vcov(iip1,jjm,llm),ucov(iip1,jjp1,llm) ! vents covariants
       REAL h(iip1,jjp1,llm),ps(iip1,jjp1)
-      REAL q(iip1,jjp1,llm,nqmx),qtot(iip1,jjp1,llm)
+      REAL q(iip1,jjp1,llm,nqtot),qtot(iip1,jjp1,llm)
 
 c autre variables dynamique nouvelle grille
@@ -103,5 +102,5 @@
       REAL co2ice(ngridmx) ! CO2 ice layer
       REAL emis(ngridmx)
-      REAL q2(ngridmx,nlayermx+1),qsurf(ngridmx,nqmx)
+      REAL q2(ngridmx,nlayermx+1),qsurf(ngridmx,nqtot)
 c     REAL phisfi(ngridmx)
 
@@ -130,5 +129,5 @@
       real inertiedatS(iip1,jjp1,nsoilmx)
       real co2iceS(iip1,jjp1),emisS(iip1,jjp1)
-      REAL q2S(iip1,jjp1,llm+1),qsurfS(iip1,jjp1,nqmx)
+      REAL q2S(iip1,jjp1,llm+1),qsurfS(iip1,jjp1,nqtot)
 
       real ptotal, co2icetotal
@@ -193,5 +192,5 @@
 ! check if tracers follow old naming convention (q01, q02, q03, ...)
       counter=0
-      do iq=1,nqmx
+      do iq=1,nqtot
         txt= " "
         write(txt,'(a1,i2.2)')'q',iq
@@ -205,5 +204,5 @@
         endif
       enddo
-      if (counter.eq.nqmx) then
+      if (counter.eq.nqtot) then
         write(*,*) "lect_start_archive: tracers seem to follow old ",
      &             "naming convention (q01, q02,...)"
@@ -318,5 +317,5 @@
       allocate(psold(imold+1,jmold+1))
       allocate(phisold(imold+1,jmold+1))
-      allocate(qold(imold+1,jmold+1,lmold,nqmx))
+      allocate(qold(imold+1,jmold+1,lmold,nqtot))
       allocate(co2iceold(imold+1,jmold+1))
       allocate(tsurfold(imold+1,jmold+1))
@@ -331,5 +330,5 @@
       allocate(surfithold(imold+1,jmold+1))
       allocate(mlayerold(nsoilold))
-      allocate(qsurfold(imold+1,jmold+1,nqmx))
+      allocate(qsurfold(imold+1,jmold+1,nqtot))
 
       allocate(var (imold+1,jmold+1,llm))
@@ -748,7 +747,7 @@
 c -------------------------------------------
 ! Surface tracers:      
-      qsurfold(1:imold+1,1:jmold+1,1:nqmx)=0
-
-      DO iq=1,nqmx
+      qsurfold(1:imold+1,1:jmold+1,1:nqtot)=0
+
+      DO iq=1,nqtot
         IF (oldtracernames) THEN
           txt=" "
@@ -787,5 +786,5 @@
         ENDIF
 
-      ENDDO ! of DO iq=1,nqmx
+      ENDDO ! of DO iq=1,nqtot
 
 !-----------------------------------------------------------------------
@@ -936,7 +935,7 @@
 c -------------------------------------------
 ! Tracers:
-      qold(1:imold+1,1:jmold+1,1:lmold,1:nqmx)=0
-
-      DO iq=1,nqmx
+      qold(1:imold+1,1:jmold+1,1:lmold,1:nqtot)=0
+
+      DO iq=1,nqtot
         IF (oldtracernames) THEN
           txt=" "
@@ -966,5 +965,5 @@
         ENDIF
 
-      ENDDO ! of DO iq=1,nqmx
+      ENDDO ! of DO iq=1,nqtot
 
 
@@ -1273,5 +1272,5 @@
 
 c traceurs surface
-      do iq = 1, nqmx
+      do iq = 1, nqtot
             call interp_horiz(qsurfold(1,1,iq) ,qsurfs(1,1,iq),
      &                  imold,jmold,iim,jjm,1,
@@ -1279,8 +1278,8 @@
       enddo
 
-      call gr_dyn_fi (nqmx,iim+1,jjm+1,ngridmx,qsurfs,qsurf)
+      call gr_dyn_fi (nqtot,iim+1,jjm+1,ngridmx,qsurfs,qsurf)
 
 c traceurs 3D
-      do  iq = 1, nqmx
+      do  iq = 1, nqtot
             call interp_vert(qold(1,1,1,iq),var,lmold,llm,
      &        apsold,bpsold,aps,bps,psold,(imold+1)*(jmold+1))
@@ -1322,5 +1321,5 @@
 
 c     Periodicite :
-      do  iq = 1, nqmx
+      do  iq = 1, nqtot
          do l=1, llm
             do j = 1, jjp1
Index: /trunk/LMDZ.MARS/libf/dyn3d/newstart.F
===================================================================
--- /trunk/LMDZ.MARS/libf/dyn3d/newstart.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/dyn3d/newstart.F	(revision 1036)
@@ -16,6 +16,7 @@
 
 ! to use  'getin'
-      USE ioipsl_getincom 
-
+      use ioipsl_getincom, only: getin 
+      use infotrac, only: iniadvtrac, nqtot, tnom
+      use tracer_mod, only: noms, igcm_h2o_vap, igcm_h2o_ice
       implicit none
 
@@ -41,6 +42,6 @@
 #include "serre.h"
 #include "netcdf.inc"
-#include"advtrac.h"
-#include"tracer.h"
+!#include"advtrac.h"
+!#include"tracer.h"
 #include "datafile.h"
 c=======================================================================
@@ -72,5 +73,5 @@
       REAL vcov(iip1,jjm,llm),ucov(iip1,jjp1,llm) ! vents covariants
       REAL phis(iip1,jjp1)
-      REAL q(iip1,jjp1,llm,nqmx)               ! champs advectes
+      REAL,ALLOCATABLE :: q(:,:,:,:)               ! champs advectes
 
 c autre variables dynamique nouvelle grille
@@ -98,5 +99,5 @@
       REAL co2ice(ngridmx)	! CO2 ice layer
       REAL emis(ngridmx)	! surface emissivity
-      REAL qsurf(ngridmx,nqmx)
+      REAL,ALLOCATABLE :: qsurf(:,:)
       REAL q2(ngridmx,nlayermx+1)
 !      REAL rnaturfi(ngridmx)
@@ -179,4 +180,10 @@
       pa= 20           ! for Mars, instead of 500 (Earth)
 
+! Load tracer number and names:
+      call iniadvtrac(nqtot,numvanle)
+! allocate arrays
+      allocate(q(iip1,jjp1,llm,nqtot))
+      allocate(qsurf(ngridmx,nqtot))
+      
 c=======================================================================
 c   Choice of the start file(s) to use
@@ -323,6 +330,4 @@
 c  INITIALISATIONS DIVERSES
 c=======================================================================
-! Load tracer names:
-      call iniadvtrac(nq,numvanle)
 
       day_step=180 !?! Note: day_step is a common in "control.h"
@@ -357,5 +362,5 @@
 !    (for instance initracer needs to know about some flags, and/or
 !      'datafile' path may be changed by user)
-      call inifis(ngridmx,llm,day_ini,daysec,dtphys,
+      call inifis(ngridmx,llm,nqtot,day_ini,daysec,dtphys,
      &                latfi,lonfi,airefi,rad,g,r,cpp)
 
@@ -399,5 +404,5 @@
 
         write(*,*) 'Reading file START_ARCHIVE'
-        CALL lect_start_archive(date,tsurf,tsoil,emis,q2,
+        CALL lect_start_archive(nqtot,date,tsurf,tsoil,emis,q2,
      .   t,ucov,vcov,ps,co2ice,teta,phisold_newgrid,q,qsurf,
      &   surfith,nid)
@@ -415,10 +420,10 @@
         write(*,*) 'Reading file START'
         fichnom = 'start.nc'
-        CALL dynetat0(fichnom,nqmx,vcov,ucov,teta,q,masse,
+        CALL dynetat0(fichnom,nqtot,vcov,ucov,teta,q,masse,
      .       ps,phis,time)
 
         write(*,*) 'Reading file STARTFI'
         fichnom = 'startfi.nc'
-        CALL phyetat0 (fichnom,tab0,Lmodif,nsoilmx,nqmx,
+        CALL phyetat0 (fichnom,tab0,Lmodif,nsoilmx,nqtot,
      .        day_ini,time,
      .        tsurf,tsoil,emis,q2,qsurf,co2ice)
@@ -448,5 +453,5 @@
 ! rename them
       count=0
-      do iq=1,nqmx
+      do iq=1,nqtot
         txt=" "
         write(txt,'(a1,i2.2)') 'q',iq
@@ -454,14 +459,14 @@
           count=count+1
         endif
-      enddo ! of do iq=1,nqmx
+      enddo ! of do iq=1,nqtot
       
       ! initialize tracer names noms(:) and indexes (igcm_co2, igcm_h2o_vap, ...)
-      call initracer(qsurf,co2ice)
+      call initracer(ngridmx,nqtot,qsurf,co2ice)
       
-      if (count.eq.nqmx) then
+      if (count.eq.nqtot) then
         write(*,*) 'Newstart: updating tracer names'
         ! copy noms(:) to tnom(:) to have matching tracer names in physics
         ! and dynamics
-        tnom(1:nqmx)=noms(1:nqmx)
+        tnom(1:nqtot)=noms(1:nqtot)
       endif
 
@@ -693,5 +698,5 @@
          if (yes.eq.'y') then
            write(*,*) 'OK : conservation of tracer total mass'
-           DO iq =1, nqmx
+           DO iq =1, nqtot
              DO l=1,llm
                DO j=1,jjp1
@@ -712,12 +717,12 @@
          do while (yes.eq.'y')
           write(*,*) 'Which tracer name do you want to change ?'
-          do iq=1,nqmx
+          do iq=1,nqtot
             write(*,'(i3,a3,a20)')iq,' : ',trim(tnom(iq))
           enddo
           write(*,'(a35,i3)')
-     &            '(enter tracer number; between 1 and ',nqmx
+     &            '(enter tracer number; between 1 and ',nqtot
           write(*,*)' or any other value to quit this option)'
           read(*,*) iq
-          if ((iq.ge.1).and.(iq.le.nqmx)) then
+          if ((iq.ge.1).and.(iq.le.nqtot)) then
             write(*,*)'Change tracer name ',trim(tnom(iq)),' to ?'
             read(*,*) txt
@@ -728,5 +733,5 @@
 ! inapropiate value of iq; quit this option
             yes='n'
-          endif ! of if ((iq.ge.1).and.(iq.le.nqmx))
+          endif ! of if ((iq.ge.1).and.(iq.le.nqtot))
          enddo ! of do while (yes.ne.'y')
 
@@ -736,5 +741,5 @@
 c          mise a 0 des q (traceurs)
           write(*,*) 'Tracers set to 0 (1.E-30 in fact)'
-           DO iq =1, nqmx
+           DO iq =1, nqtot
              DO l=1,llm
                DO j=1,jjp1
@@ -747,5 +752,5 @@
 
 c          set surface tracers to zero
-           DO iq =1, nqmx
+           DO iq =1, nqtot
              DO ig=1,ngridmx
                  qsurf(ig,iq)=0.
@@ -757,10 +762,10 @@
         else if (trim(modif) .eq. 'q=x') then
              write(*,*) 'Which tracer do you want to modify ?'
-             do iq=1,nqmx
+             do iq=1,nqtot
                write(*,*)iq,' : ',trim(tnom(iq))
              enddo
-             write(*,*) '(choose between 1 and ',nqmx,')'
+             write(*,*) '(choose between 1 and ',nqtot,')'
              read(*,*) iq 
-             if ((iq.lt.1).or.(iq.gt.nqmx)) then
+             if ((iq.lt.1).or.(iq.gt.nqtot)) then
                ! wrong value for iq, go back to menu
                write(*,*) "wrong input value:",iq
@@ -793,10 +798,10 @@
              write(*,*) "followed by 2nd, etc. up to top of atmosphere)"
              write(*,*) 'Which tracer do you want to set?'
-             do iq=1,nqmx
+             do iq=1,nqtot
                write(*,*)iq,' : ',trim(tnom(iq))
              enddo
-             write(*,*) '(choose between 1 and ',nqmx,')'
+             write(*,*) '(choose between 1 and ',nqtot,')'
              read(*,*) iq 
-             if ((iq.lt.1).or.(iq.gt.nqmx)) then
+             if ((iq.lt.1).or.(iq.gt.nqtot)) then
                ! wrong value for iq, go back to menu
                write(*,*) "wrong input value:",iq
@@ -853,10 +858,10 @@
           endif
           
-          call inichim_newstart(q, qsurf, ps, flagh2o, flagthermo)
+          call inichim_newstart(nq, q, qsurf, ps, flagh2o, flagthermo)
 
          ! We want to have the very same value at lon -180 and lon 180
           do l = 1,llm
              do j = 1,jjp1
-                do iq = 1,nqmx
+                do iq = 1,nqtot
                    q(iip1,j,l,iq) = q(1,j,l,iq)
                 end do
@@ -892,5 +897,5 @@
           do l = 1,llm
              do j = 1,jjp1
-                do iq = 1,nqmx
+                do iq = 1,nqtot
                    q(iip1,j,l,iq) = q(1,j,l,iq)
                 end do
@@ -1460,15 +1465,15 @@
 c    $    phi,conser,du,dv,dteta,dp,w, pbaru,pbarv, day_ini )
 
-      CALL dynredem0("restart.nc",day_ini,anneeref,phis,nqmx)
+      CALL dynredem0("restart.nc",day_ini,anneeref,phis,nqtot)
       CALL dynredem1("restart.nc",hour_ini,vcov,ucov,teta,q,
-     .               nqmx,masse,ps)
+     .               nqtot,masse,ps)
 C
 C Ecriture etat initial physique
 C
 
-      call physdem0("restartfi.nc",lonfi,latfi,nsoilmx,nqmx,
+      call physdem0("restartfi.nc",lonfi,latfi,nsoilmx,nqtot,
      .              dtphys,real(day_ini),0.0,
      .              airefi,albfi,ithfi,zmea,zstd,zsig,zgam,zthe)
-      call physdem1("restartfi.nc",nsoilmx,nqmx,
+      call physdem1("restartfi.nc",nsoilmx,nqtot,
      .              dtphys,hour_ini,
      .              tsurf,tsoil,co2ice,emis,q2,qsurf)
Index: /trunk/LMDZ.MARS/libf/dyn3d/paramet.h
===================================================================
--- /trunk/LMDZ.MARS/libf/dyn3d/paramet.h	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/dyn3d/paramet.h	(revision 1036)
@@ -3,5 +3,5 @@
 
       INTEGER  iip1,iip2,iip3,jjp1,llmp1,llmp2,llmm1
-      INTEGER  kftd,ip1jm,ip1jmp1,ip1jmi1,ijp1llm
+      INTEGER  ip1jm,ip1jmp1,ip1jmi1,ijp1llm
       INTEGER  ijmllm,mvar
       INTEGER jcfil,jcfllm
@@ -10,5 +10,4 @@
       PARAMETER( jjp1=jjm+1-1/jjm)
       PARAMETER( llmp1 = llm+1,  llmp2 = llm+2, llmm1 = llm-1 )
-      PARAMETER( kftd  = iim/2 -ndm )
       PARAMETER( ip1jm  = iip1*jjm,  ip1jmp1= iip1*jjp1 )
       PARAMETER( ip1jmi1= ip1jm - iip1 )
Index: /trunk/LMDZ.MARS/libf/dyn3d/start2archive.F
===================================================================
--- /trunk/LMDZ.MARS/libf/dyn3d/start2archive.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/dyn3d/start2archive.F	(revision 1036)
@@ -19,4 +19,5 @@
 c=======================================================================
 
+      use infotrac, only: iniadvtrac, nqtot, tnom
       implicit none
 
@@ -35,5 +36,5 @@
 #include "dimphys.h"
 #include "comsoil.h"
-#include"advtrac.h"
+!#include"advtrac.h"
 #include "netcdf.inc"
 
@@ -46,5 +47,5 @@
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) ! vents covariants
       REAL teta(ip1jmp1,llm)                    ! temperature potentielle 
-      REAL q(ip1jmp1,llm,nqmx)               ! champs advectes
+      REAL,ALLOCATABLE :: q(:,:,:)   ! champs advectes
       REAL pks(ip1jmp1)                      ! exner (f pour filtre)
       REAL pk(ip1jmp1,llm)
@@ -61,5 +62,6 @@
       REAL tsoil(ngridmx,nsoilmx) ! Soil temperature
       REAL co2ice(ngridmx)	! CO2 ice layer
-      REAL q2(ngridmx,nlayermx+1),qsurf(ngridmx,nqmx)
+      REAL q2(ngridmx,nlayermx+1)
+      REAL,ALLOCATABLE :: qsurf(:,:)
       REAL emis(ngridmx)
       INTEGER start,length
@@ -75,5 +77,6 @@
       REAL ithS(ip1jmp1,nsoilmx) ! Soil Thermal Inertia
       REAL co2iceS(ip1jmp1)
-      REAL q2S(ip1jmp1,llm+1),qsurfS(ip1jmp1,nqmx)
+      REAL q2S(ip1jmp1,llm+1)
+      REAL,ALLOCATABLE :: qsurfS(:,:)
       REAL emisS(ip1jmp1)
 
@@ -116,9 +119,14 @@
 c Lecture des donnees
 c=======================================================================
-! Load tracer names:
-      call iniadvtrac(nq,numvanle)
+! Load tracer number and names:
+      call iniadvtrac(nqtot,numvanle)
+
+! allocate arrays:
+      allocate(q(ip1jmp1,llm,nqtot))
+      allocate(qsurf(ngridmx,nqtot))
+      allocate(qsurfS(ip1jmp1,nqtot))
 
       fichnom = 'start.nc'
-      CALL dynetat0(fichnom,nqmx,vcov,ucov,teta,q,masse,
+      CALL dynetat0(fichnom,nqtot,vcov,ucov,teta,q,masse,
      .       ps,phis,timedyn)
 
@@ -127,5 +135,5 @@
       Lmodif=0
 
-      CALL phyetat0 (fichnom,0,Lmodif,nsoilmx,nqmx,day_ini_fi,timefi,
+      CALL phyetat0 (fichnom,0,Lmodif,nsoilmx,nqtot,day_ini_fi,timefi,
      .      tsurf,tsoil,emis,q2,qsurf,co2ice)
 
@@ -233,5 +241,5 @@
       call gr_fi_dyn(1,ngridmx,iip1,jjp1,emis,emisS)
       call gr_fi_dyn(llm+1,ngridmx,iip1,jjp1,q2,q2S)
-      call gr_fi_dyn(nqmx,ngridmx,iip1,jjp1,qsurf,qsurfS)
+      call gr_fi_dyn(nqtot,ngridmx,iip1,jjp1,qsurf,qsurfS)
 
 c=======================================================================
@@ -334,7 +342,7 @@
 
 c-----------------------------------------------------------------------
-c Ecriture du champs  q  ( q[1,nqmx] )
-c-----------------------------------------------------------------------
-      do iq=1,nqmx
+c Ecriture du champs  q  ( q[1,nqtot] )
+c-----------------------------------------------------------------------
+      do iq=1,nqtot
 c       write(str2,'(i2.2)') iq
 c        call write_archive(nid,ntime,'q'//str2,'tracer','kg/kg',
@@ -344,7 +352,7 @@
       end do
 c-----------------------------------------------------------------------
-c Ecriture du champs  qsurf  ( qsurf[1,nqmx] )
-c-----------------------------------------------------------------------
-      do iq=1,nqmx
+c Ecriture du champs  qsurf  ( qsurf[1,nqtot] )
+c-----------------------------------------------------------------------
+      do iq=1,nqtot
 c       write(str2,'(i2.2)') iq
 c       call write_archive(nid,ntime,'qsurf'//str2,'Tracer on surface',
Index: /trunk/LMDZ.MARS/libf/dyn3d/test_period.F
===================================================================
--- /trunk/LMDZ.MARS/libf/dyn3d/test_period.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/dyn3d/test_period.F	(revision 1036)
@@ -6,5 +6,6 @@
 c                           teta, q , p et phis                 .......... 
 c
-c     IMPLICIT NONE
+      use infotrac,only: nqtot
+      IMPLICIT NONE
 c
 #include "dimensions.h"
@@ -14,5 +15,5 @@
 c
       REAL ucov(ip1jmp1,llm), vcov(ip1jm,llm), teta(ip1jmp1,llm) ,
-     ,      q(ip1jmp1,llm,nqmx), p(ip1jmp1,llmp1), phis(ip1jmp1)
+     ,      q(ip1jmp1,llm,nqtot), p(ip1jmp1,llmp1), phis(ip1jmp1)
 c
 c   .....  Variables  locales  .....
@@ -56,5 +57,5 @@
       
 c
-      DO nq =1, nqmx
+      DO nq =1, nqtot
         DO l =1, llm
           DO ij = 1, ip1jmp1, iip1
Index: /trunk/LMDZ.MARS/libf/grid/dimension/makdim
===================================================================
--- /trunk/LMDZ.MARS/libf/grid/dimension/makdim	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/grid/dimension/makdim	(revision 1036)
@@ -1,8 +1,7 @@
-nqmx=$1
-shift
+
 for i in $* ; do
    list=$list.$i
 done
-fichdim=dimensions${list}.t${nqmx}
+fichdim=dimensions${list}
 
 
@@ -15,5 +14,5 @@
    lm=$3
    n2=$1
-   ndm=1
+#   ndm=1
 
 #  while [ "$n2" -gt 2 ]; do
@@ -30,10 +29,10 @@
        jm=$1
       lm=$2
-      ndm=1
+#      ndm=1
  else if [ $# -ge 1 ] ; then
          im=1
          jm=1
          lm=$1
-         ndm=1
+#         ndm=1
  else
          echo il faut au moins une dimension
@@ -49,13 +48,9 @@
 !   dimensions.h contient les dimensions du modele
 !   ndm est tel que iim=2**ndm
-!   nqmx est la dimension de la variable traceur q
 !-----------------------------------------------------------------------
 
-      INTEGER, parameter :: iim= $im
+      INTEGER, parameter :: iim=$im
       INTEGER, parameter :: jjm=$jm
       INTEGER, parameter :: llm=$lm
-      INTEGER, parameter :: ndm=$ndm
-
-      integer, parameter :: nqmx=$nqmx
 
 !-----------------------------------------------------------------------
Index: /trunk/LMDZ.MARS/libf/phymars/aeropacity.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/aeropacity.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/aeropacity.F	(revision 1036)
@@ -4,5 +4,7 @@
                                                    
 ! to use  'getin'
-      USE ioipsl_getincom 
+      USE ioipsl_getincom, only: getin
+      use tracer_mod, only: noms, igcm_h2o_ice, igcm_dust_mass,
+     &                      igcm_dust_submicron, rho_dust, rho_ice
        IMPLICIT NONE
 c=======================================================================
@@ -53,5 +55,5 @@
 #include "dimradmars.h"
 #include "yomaer.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "planete.h"
 #include "aerkind.h"
@@ -119,5 +121,5 @@
 
 ! indexes of water ice and dust tracers:
-      INTEGER,SAVE :: nqdust(nqmx) ! to store the indexes of dust tracers
+      INTEGER,ALLOCATABLE,SAVE :: nqdust(:) ! to store the indexes of dust tracers
       INTEGER,SAVE :: i_ice=0  ! water ice
       real,parameter :: odpref=610. ! DOD reference pressure (Pa)
@@ -143,4 +145,5 @@
         ENDDO
         ! identify tracers which are dust
+        allocate(nqdust(nq))
         i=0
         DO iq=1,nq
Index: /trunk/LMDZ.MARS/libf/phymars/callradite.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/callradite.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/callradite.F	(revision 1036)
@@ -272,5 +272,5 @@
           name_iaer(1) = "dust_conrath"   !! default choice is good old Conrath profile
           IF (doubleq.AND.active) name_iaer(1) = "dust_doubleq" !! two-moment scheme
-          if (nqmx.gt.1) then
+          if (nq.gt.1) then
            ! trick to avoid problems compiling with 1 tracer
            ! and picky compilers who know name_iaer(2) is out of bounds
@@ -278,5 +278,5 @@
           IF (water.AND.activice) name_iaer(j) = "h2o_ice"      !! radiatively-active clouds
           IF (submicron.AND.active) name_iaer(j) = "dust_submicron" !! JBM experimental stuff
-          endif ! of if (nqmx.gt.1)
+          endif ! of if (nq.gt.1)
 c        ----------------------------------------------------------
 
Index: /trunk/LMDZ.MARS/libf/phymars/callsedim.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/callsedim.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/callsedim.F	(revision 1036)
@@ -5,6 +5,10 @@
      &                tau,tauscaling)
 ! to use  'getin'
-      USE ioipsl_getincom
-      USE updaterad,only: updaterdust,updaterice_micro,updaterice_typ
+      USE ioipsl_getincom, only: getin
+      USE updaterad, only: updaterdust,updaterice_micro,updaterice_typ
+      USE tracer_mod, only: noms, igcm_dust_mass, igcm_dust_number,
+     &                      rho_dust, rho_q, radius, varian,
+     &                      igcm_ccn_mass, igcm_ccn_number,
+     &                      igcm_h2o_ice, nuice_sed, nuice_ref 
       IMPLICIT NONE
 
@@ -28,5 +32,5 @@
 #include "dimphys.h"
 #include "comcstfi.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "callkeys.h"
 
Index: /trunk/LMDZ.MARS/libf/phymars/calltherm_interface.F90
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/calltherm_interface.F90	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/calltherm_interface.F90	(revision 1036)
@@ -45,4 +45,5 @@
 
       use comtherm_h
+      use tracer_mod, only: nqmx,noms
       implicit none
 
Index: /trunk/LMDZ.MARS/libf/phymars/convadj.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/convadj.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/convadj.F	(revision 1036)
@@ -6,4 +6,6 @@
      &                   pdqadj)
 
+      use tracer_mod, only: noms, ! tracer names
+     &                      igcm_h2o_vap ! index of water vapor tracer
       implicit none
 
@@ -33,5 +35,5 @@
 #include "comcstfi.h"
 #include "callkeys.h"
-#include "tracer.h"
+!#include "tracer.h"
 
 
@@ -73,6 +75,6 @@
       INTEGER iq,ico2
       save ico2
-      REAL zq(ngridmx,nlayermx,nqmx), zq2(ngridmx,nlayermx,nqmx)
-      REAL zqm(nqmx),zqco2m
+      REAL zq(ngridmx,nlayermx,nq), zq2(ngridmx,nlayermx,nq)
+      REAL zqm(nq),zqco2m
       real m_co2, m_noco2, A , B
       save A, B
@@ -101,5 +103,5 @@
         if (tracer) then
 !     Prepare Special treatment if one of the tracers is CO2 gas
-           do iq=1,nqmx
+           do iq=1,nq
              if (noms(iq).eq."co2") then
                 ico2=iq
Index: /trunk/LMDZ.MARS/libf/phymars/dustdevil.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/dustdevil.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/dustdevil.F	(revision 1036)
@@ -1,4 +1,6 @@
       SUBROUTINE dustdevil(ngrid,nlay,nq, pplev,pu,pv,pt, ptsurf,pq2,
      &                pdqdev,pdqs_dev)
+
+      use tracer_mod, only: alpha_devil
       IMPLICIT NONE
 
@@ -32,5 +34,5 @@
 #include "surfdat.h"
 #include "comgeomfi.h"
-#include "tracer.h"
+!#include "tracer.h"
 c   arguments:
 c   ----------
Index: /trunk/LMDZ.MARS/libf/phymars/dustlift.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/dustlift.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/dustlift.F	(revision 1036)
@@ -2,4 +2,6 @@
      $                  pcdh_true,pcdh,co2ice,
      $                  dqslift)
+
+      use tracer_mod, only: alpha_lift, radius
       IMPLICIT NONE
 
@@ -19,5 +21,5 @@
 #include "dimphys.h"
 #include "comcstfi.h"
-#include "tracer.h"
+!#include "tracer.h"
 
 c
Index: /trunk/LMDZ.MARS/libf/phymars/growthrate.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/growthrate.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/growthrate.F	(revision 1036)
@@ -1,4 +1,5 @@
       subroutine growthrate(temp,pmid,psat,rcrystal,res)
 
+      use tracer_mod, only: rho_ice
       IMPLICIT NONE
 
@@ -21,5 +22,5 @@
 #include "dimphys.h"
 #include "comcstfi.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "microphys.h"
 
Index: /trunk/LMDZ.MARS/libf/phymars/improvedclouds.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/improvedclouds.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/improvedclouds.F	(revision 1036)
@@ -6,4 +6,8 @@
       USE ioipsl_getincom
       USE updaterad
+      use tracer_mod, only: rho_ice, nuice_sed, igcm_h2o_vap,
+     &                      igcm_h2o_ice, igcm_dust_mass,
+     &                      igcm_dust_number, igcm_ccn_mass,
+     &                      igcm_ccn_number
       implicit none
       
@@ -33,5 +37,5 @@
 #include "comcstfi.h"
 #include "callkeys.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "comgeomfi.h"
 #include "dimradmars.h"
@@ -73,6 +77,6 @@
       INTEGER ig,l,i
       
-      REAL zq(ngridmx,nlayermx,nqmx)  ! local value of tracers
-      REAL zq0(ngridmx,nlayermx,nqmx) ! local initial value of tracers
+      REAL zq(ngridmx,nlayermx,nq)  ! local value of tracers
+      REAL zq0(ngridmx,nlayermx,nq) ! local initial value of tracers
       REAL zt(ngridmx,nlayermx)       ! local value of temperature
       REAL zqsat(ngridmx,nlayermx)    ! saturation
